#include <compat.h>
#include <error.h>
#include <flash.h>

void *EM_All_AMS_GetArchiveMemoryBeginning(void)
{
    // Skip the two first sectors (boot and reserved to OS).
    register void *result = (void*)((unsigned char*)ROM_base + 2 * 0x10000 + 2);
    register short cont = 1;
    static unsigned short data = 0xFFFF;

    while (cont)
    {
        TRY
            // We try to write 0xFFFF to the Flash. In other words, nothing
            // is actually written to the Flash.
            // Passing 0 as length doesn't work...
            EM_write(&data, result, 2);
            cont = 0;
        ONERR
            (unsigned char *)result += 0x10000;
        ENDTRY
    }
    return ((unsigned char*)result - 2);
}
