// Sends the list of all variables and folders through the link port.
// This program does what HeapWalk(H_WALK_SYM); does on AMS 2.04 and
// later, but also works on any AMS version with at least 0x3CC
// ROM_CALLs.

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define SAVE_SCREEN           // Save/Restore LCD Contents
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define NO_CALC_DETECT
#define MIN_AMS 101           // Compile for AMS 1.01 or higher

#include <tigcclib.h>         // Include All Header Files

void _main(void)
{
SYM_ENTRY *symptr;
unsigned char buffer[256];
SymPG_S save;
TRY
  memcpy(&save, pSymPG, sizeof(SymPG_S));
  if ((symptr = SymFindFirst(NULL,2)) != NULL)
  {
    strcpy(buffer, "\r\nName/Flags/hVal (dec)\r\n");
    LIO_SendData(buffer, strlen((char*)buffer));
    do
    {
      short flags = symptr->flags.flags_n;
      if ((flags&SF_FOLDER))
        sprintf((char *)buffer, "FOLDER: %-8s   %04X  %hd\r\n", symptr->name,
        flags, symptr->handle);
      else
        sprintf((char *)buffer, "%8s\\%-8s %04X  %hd\r\n", SymFindFolderName(),
        symptr->name, flags, symptr->handle);
      LIO_SendData(buffer, strlen((char *)buffer));
      symptr = SymFindNext();
    } while (symptr != NULL);
  }
FINALLY
  memcpy(pSymPG, &save, sizeof(SymPG_S));
ENDFINAL
}
