| This function is mainly similar to the AMS 2.02+ system function
| LOC_formatDate (ROM_CALL 590). The differences are:
| * this routine works on any AMS version.
| * this routine is faster than LOC_formatDate.
| * this routine returns immediately if month or day are incorrect.
| * this routine receives its parameters in the registers.
| * this routine behaves slightly differently from LOC_formatDate when
| -9 <= year <= -1.
|
| Copyright  2002-2003 Lionel Debroux, designed for TIGCCLIB.

.data
        .xdef _LOC_formatDate
        .even
_LOC_formatDate:
| Check if day and month are correct...
        cmpi.w   #31,%d2
        bcc.s    __end_LOCFD__
        cmpi.w   #12,%d1
        bcc.s    __end_LOCFD__
        movem.l  %d3-%d5/%a2-%a3,-(%sp)
        
| Save all parameters in registers that can't be destroyed.
        move.w   %d0,%d3
        move.w   %d1,%d4
        move.w   %d2,%d5
        move.l   %a0,%a2
        move.l   %a1,%a3
        
__get_byte_LOCFD__:
        moveq    #0,%d0 | Clear d0.
        move.b   (%a2)+,%d0
        bne.s    __process_bytes_LOCFD__
        clr.b    (%a3)
        movem.l  (%sp)+,%d3-%d5/%a2-%a3
__end_LOCFD__:
        rts

__process_bytes_LOCFD__:
        moveq    #'Y',%d1
        cmp.b    %d1,%d0
        bne.s    __month_LOCFD__
        cmp.b    (%a2),%d1
        bne.s    __month_LOCFD__
        move.w   %d3,%d0
        bge.s    __year_not_negative_LOCFD__
        move.b   #'-',(%a3)+
        neg.w    %d0
__year_not_negative_LOCFD__:
        cmp.b    1(%a2),%d1
        bne.s    __year_2_digits_LOCFD__
        cmp.b    2(%a2),%d1
        bne.s    __year_2_digits_LOCFD__
        addq.l   #3,%a2
        pea      0x00040001 | 4, TRUE.
__print_the_year_or_month_or_day_LOCFD__:
        move.l   %a3,%a0
        jbsr     itoa_ushort_10_extended | Use tigcc.a functions...
        addq.l   #4,%sp
        adda.w   %d0,%a3
        bra.s    __get_byte_LOCFD__
__year_2_digits_LOCFD__:
        divs.w   #100,%d0
        clr.w    %d0
        swap     %d0

__month_or_day_min_2_digits_LOCFD__:
        addq.l   #1,%a2
        pea      0x00020001 | 0, TRUE.
        bra.s    __print_the_year_or_month_or_day_LOCFD__

__month_LOCFD__:
        moveq    #'M',%d1
        cmp.b    %d1,%d0
        bne.s    __day_LOCFD__
        move.w   %d4,%d0
__month_not_negative_LOCFD__:
        cmp.b    (%a2),%d1
        beq.s    __month_or_day_min_2_digits_LOCFD__
__month_or_day_no_min_digits_LOCFD__:
|        addq.l   #1,%a2
        pea      0x00000001.w | 0, TRUE.
        bra.s    __print_the_year_or_month_or_day_LOCFD__

__day_LOCFD__:
        moveq    #'D',%d1
        cmp.b    %d1,%d0
        bne.s    __other_byte_LOCFD__
        move.w   %d5,%d0
__day_not_negative_LOCFD__:
        cmp.b    (%a2),%d1
        bne.s    __month_or_day_no_min_digits_LOCFD__
        bra.s    __month_or_day_min_2_digits_LOCFD__

__other_byte_LOCFD__:
        move.b   %d0,(%a3)+
        jra      __get_byte_LOCFD__
