| This routine is the generic routine for itoa_xxx_xx_extended__
| routines. If this function didn't exist, there would be a huge space waste
| if there was more than one itoa_xxx_xx_extended__ function used...
|
| CAUTION: This function assumes that the buffer it is given is large enough
| to store the full string, padded if necessary. If it isn't the case, this
| function has no means to know it, so it writes out of the bounds of the
| buffer. I hope you know that this usually leads to Line 1111 Emulator,
| Illegal Instruction or Address Error...
|
| Copyright  2002-2004 Lionel Debroux, designed for TIGCCLIB.

.data
        .xdef __itoa_extended__
        .even
__itoa_extended__:
        cmp.w    %d0,%d1
| If d1 <= d0, that's over and we can return. The 0x00 terminating the 
| string was put by itoa_xxx_xx__, so we just return.
        ble.s    __end_ie__
| > 0, so we have to put padding charcters...

| We have to save d3 which is not supposed to be destroyed.
        move.l   %d3,-(%sp)
        
| We process the fourth parameter of the function.
        moveq    #' ',%d3
        tst.w    %d2
        beq.s    __d2_can_be_reused_ie__
        moveq    #'0',%d3

__d2_can_be_reused_ie__:
| Save return value.
        move.w   %d1,-(%sp)

        sub.w    %d0,%d1
        subq.w   #1,%d0
        move.w   %d0,%d2
        subq.w   #1,%d1

| Copy string returned by itoa_xxx_xx__ on the stack.
        lea      -12(%sp),%sp
        move.l   %sp,%a1

| The 68000 is inefficient in tight loop mode (CPU32 and above are better),
| but it is not very likely that the user will ask for a great number of 
| digits that would require "doubling" the moves. There is no point in asking 
| more than 10 digits for a long and 5 for a short in decimal representation,
| 8 digits for a long and 4 for a short in hexadecimal representation...
__save_string_ie__:
        move.b   (%a0)+,(%a1)+
        dbf      %d2,__save_string_ie__

| Correct a0 and a1 to get back to the beginning of the strings.
        suba.w   %d0,%a0
        subq.l   #1,%a0
        move.l   %sp,%a1
|        neg.w    %d0
|        lea      -1(%a0,%d0.w),%a0
|        neg.w    %d0
|        lea      -12(%sp),%a1
        
| Put the padding spaces/zeros at the beginning of the string to write to.
__put_padding_characters_ie__:
        move.b   %d3,(%a0)+
        dbf      %d1,__put_padding_characters_ie__

| Copy string returned by itoa_xxx_xx__ after the spaces/zeros.
__restore_string_ie__:
        move.b   (%a1)+,(%a0)+
        dbf      %d0,__restore_string_ie__

| Null-terminate the string.
        clr.b    (%a0)

| Return value.
        lea      12(%sp),%sp
        move.w   (%sp)+,%d0
        move.l   (%sp)+,%d3

__end_ie__:
        rts
