// C Source File
// Created 19/09/2003; 13:04:45

// LOC_... functions and ROM_CALL_58E don't exist on AMS 2.01- (they are not
// in the jump table and the routines themselves don't exist).
#define NO_CALC_DETECT
#define NO_EXIT_SUPPORT
#define MIN_AMS 202

#include <tigcclib.h>         // Include All Header Files

// The prototype of LOC_formatDate is wrong in TIGCC due to a bug in
// UpdateInclude.exe !
#undef LOC_formatDate         
#undef LOC_getLocalDateFormat

#define ROM_CALL_58E _rom_call(void,(CERT_FIELD*,__pushort,__pushort,__pushort,__pushort,__pushort,__pushort),58E)
#define LOC_getLocalDateFormat _rom_call(char const*,(void),58F)
#define LOC_formatDate _rom_call(void,(char const*,short,short,short,char*),590)

// cert is global in order to avoid a copy of it on the stack, which makes
// the program bigger.
CERT_FIELD cert = {0x0900,0x0002,0x00000004,NULL};

// Main Function
void _main(void)
{
    ESI argptr;
    unsigned char argtype;
    unsigned long num;
    unsigned short s1, s2, s3, s4, s5, s6;
    unsigned char string2[20];
    unsigned char string[80];

    InitArgPtr(argptr);
    argtype = GetArgType(argptr);
    if (argtype != POSINT_TAG) {
        push_zstr("Use: decode(integer)");
        return;
    }

    num = GetIntArg(argptr);
    cert.Data = &num;
    
    ROM_CALL_58E(&cert,&s1,&s2,&s3,&s4,&s5,&s6);
    // Use LOC_getLocalDateFormat so as to output the date in the format the
    // user usually uses.
    LOC_formatDate(LOC_getLocalDateFormat(),s1,s2,s3,string2);

    sprintf(string,"Date represented by %luUL (0x%lXUL) is %s, %02huh %02hum %02hus",
                   num,num,string2,s4,s5,s6);

    push_zstr(string);
}
