| Fast routine for printing an unsigned long in base 10.
|
| Copyright  2002-2004 Lionel Debroux, designed for TIGCCLIB.

.data
        .xdef itoa_ulong_10
        .even
itoa_ulong_10:
        move.w   %d3,-(%sp)
        lea      -12(%sp),%sp
        movea.l  %sp,%a1
        moveq    #10,%d1
        cmp.l    %d1,%d0
        bcc.s    __iul10_loop__

        addi.b   #'0',%d0
        move.b   %d0,(%a0)+
        moveq    #1,%d0
        bra.s    __iul10_cleanup_and_bye__
| Clear the register...
        moveq    #0,%d2

__iul10_loop__:
        divu.w   %d1,%d0
| No need to make three divisions if one is enough...
        bvc.s    __iul10_no_overflow__

| Copy to the registers.
        move.l   %d0,%d2
        clr.w    %d0
        swap     %d0

| Make the divisions.
        divu.w   %d1,%d0
        move.w   %d0,%d3
        move.w   %d2,%d0
        divu.w   %d1,%d0

        swap     %d0
        addi.b   #'0',%d0
        move.b   %d0,(%a1)+
        move.w   %d3,%d0
        swap     %d0
| If we come here, that's because we are dividing by ten an integer >0x99999.
| As a consequence, there is no need to test if it is <10...

        bra.s    __iul10_loop__
__iul10_no_overflow__:
        swap     %d0

| d0.w = remainder in the division of d2 by 10.
        addi.b   #'0',%d0
        move.b   %d0,(%a1)+

        clr.w    %d0
        swap     %d0

        cmp.l    %d1,%d0
        bcc.s    __iul10_loop__
        addi.b   #'0',%d0
        move.b   %d0,(%a0)+
__iul10_prepare_copy__:
        move.l   %a1,%d1
        sub.l    %sp,%d1
        move.w   %d1,%d0
        addq.b   #1,%d0
        subq.b   #1,%d1
__iul10_copy__:
        move.b   -(%a1),(%a0)+
        dbf      %d1,__iul10_copy__
__iul10_cleanup_and_bye__:
        clr.b    (%a0)
        lea      12(%sp),%sp
        move.w   (%sp)+,%d3
        rts
