| This function is an extension to itoa_ushort_10__: it provides support
| for a minimal number of digits, and a choice between spaces and zeros as
| padding characters at the left, if necessary.
| All itoa_xxx_xx_extended__ functions call __itoa_extended__, it's
| much more interesting size-wise if more than one itoa_xxx_xx_extended__
| function is called.
|
| CAUTION: This function assumes that the buffer it is given is large enough
| to store the full string, padded if necessary. If it isn't the case, this
| function has no means to know it, so it writes out of the bounds of the
| buffer. I hope you know that this usually leads to Line 1111 Emulator,
| Illegal Instruction or Address Error...
|
| Copyright  2002-2004 Lionel Debroux, designed for TIGCCLIB.

.data
        .xdef itoa_ushort_10_extended
        .even
itoa_ushort_10_extended:
| Save what will be destroyed.
        pea      (%a0)
        
| Call itoa_ushort_10.
        jbsr     itoa_ushort_10

| String to write to.
        move.l   (%sp)+,%a0

| Minimal number of characters.
        move.w   4(%sp),%d1

| Trailing bytes: spaces or zeros ?
        move.w   6(%sp),%d2
        
| Branch to the generic __itoa_extended__ routine, which does just put
| padding spaces/zeros if necessary...
        jra     __itoa_extended__
