| Fast routine for printing an unsigned short in hexadecimal (uppercase
| letters).
| I decided to put redundant immediate values in the andi, not putting 0xF
| in a register, because it would need saving/restoring another register
| (min +2*12 clocks). Here, we have 4 andi costing +4*4 clocks...
| Also, there is a size optimization when d0 = 0.
|
| Copyright  2002-2004 Lionel Debroux, designed for TIGCCLIB.

.data
        .xdef itoa_ushort_16_lower
        .even
itoa_ushort_16_lower:
        pea      (%a0)

        tst.w    %d0
        beq.s    __ius16l_zero__
| Short branches are faster if not taken.
        moveq    #4-1,%d2
        lea      __itoa_16L_table__,%a1
__ius16l_loop1__:
        rol.w    #4,%d0
        move.w   %d0,%d1
        andi.w   #0xF,%d1
        dbne     %d2,__ius16l_loop1__
        bra.s    __ius16l_loop2__

__ius16l_zero__:
| d0 = 0 (size optimization at the expense of speed).
        moveq    #0,%d2

_ius16l_loop2__:
        rol.w    #4,%d0
        move.w   %d0,%d1
        andi.w   #0xF,%d1
__ius16l_loop2__:
        move.b   0(%a1,%d1.w),(%a0)+
        dbf      %d2,_ius16l_loop2__
        
        move.l   %a0,%d0
        sub.l    (%sp)+,%d0

        clr.b    (%a0)
        rts
